<?php

namespace Vidgyor\Category;

use User;

class Category
{
    /**
     * $video_category object.
     */
    protected $video_category;

    /**
     * Constructor.
     */
    public function __construct(\Vidgyor\Category\Interfaces\VideoCategoryRepositoryInterface $video_category)
    {
        $this->video_category = $video_category;
    }

    /**
     * Returns count of category.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.video_category.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->video_category->pushCriteria(new \Litepie\Vidgyor\Repositories\Criteria\VideoCategoryUserCriteria());
        }

        $video_category = $this->video_category->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('category::' . $view, compact('video_category'))->render();
    }
}
